﻿/*jshint strict: false */
/*
	Datenübertragung für Mikrocontroller

	Dies ist nur Denkansatz.

	Programmed by Walter Boehle 2013
*/
var ueb_ist = 0;
var ueb_soll = 0;
var ueb_timeout;
var nIntervId;
var st2Intern = false;
var rechnerzeit = 'off';
var dtTimer = 10;
var snd = null;

function StartDatenabfrage() {
  nIntervId = setInterval(mcUebertragung, 100);
  ueb_timeout = 40; // 4Sek.
}
/* Attribute
fontWeight = bold   normal
frontStyle = italic	normal	
textDecoration: none underline line-through blink
0x01 = bold
0x02 = italic
0x04 = underline 
0x08 = line-through
0x10 = blink
0x20 = Foreground Color 
0x40 = Background Color
*/
function doBeep() {
//	if (snd === null)
	  snd = new Audio("styles/beep.ogg");
	if (snd !== null) {
		snd.play();
	}
}
function anzDatetime() {
	dtTimer++;
	if (rechnerzeit === 'on' && dtTimer > 9) {
		var p = document.getElementById('Statuszeile1');
		if (p !== null) {
			var dt = new Date();
			var erg = dt.getDate() + '.';
			if (dt.getMonth() + 1 < 10) { erg += '0'; }
			erg += dt.getMonth() + 1 + '.' + dt.getFullYear() + ' ' + dt.getHours() + ':';
			if (dt.getMinutes() < 10) { erg += '0'; }
			erg += dt.getMinutes() + ':';
			if (dt.getSeconds() < 10) { erg += '0'; }
			erg += dt.getSeconds() + ' LOC';
			p.innerHTML = erg;
		}
		dtTimer = 0;
//		doBeep();
	}
}	

function mcUebertragung() {
	var xmlHttp;	
	var rbuf = '';
	
	anzDatetime();	
  
	ueb_timeout--;
	if (ueb_ist < ueb_soll) {
		if (ueb_timeout <= 0) {
			st2Intern = true;
			setStatuszeile2('Keine Antwort vom Server.', 'yellow', 'red');
			ueb_timeout = 40;		
			ueb_ist++;
		}
	} else {
		try {
			xmlHttp = new XMLHttpRequest();					// Request Objekt erstellen
		} catch(e) {
			st2Intern = true;
			setStatuszeile2('Bitte neueren Browser verwenden.', 'yellow', 'red');
    }
		if (xmlHttp) {
			ueb_soll++;
			xmlHttp.open('GET', 'q_0001.mc', true);			// Datenanfrage
			xmlHttp.onreadystatechange = function () {	// Übertragungsstatus
				if (xmlHttp.readyState === 4) {						// Anfrage abgeschlossen
					rbuf = xmlHttp.responseText;
					if (rbuf.length > 1) {									// Daten vorhanden ?
						ueb_ist++;
						ueb_timeout = 20;	
						if (st2Intern) {
							st2Intern = false;
							setStatuszeile2(' ', 'black', 'black');
						}
						mcDatenAnzeigen(xmlHttp.responseText);
					}
				}
			};
			xmlHttp.send(null);		// Anfrage senden
		}
	}
}


function setStatuszeile2(txt, vg, bg) {
	var p = document.getElementById('Statuszeile2');
	if (p !== null) {
		p.style.color = vg;
		p.style.backgroundColor = bg;
		p.innerHTML = txt;
	}
}

function mcDatenAnzeigen(daten) {
	var zeilen = daten.split('\r\n');
	var keys;
//	var cmd;
	var p;
	var i;
	for (i = 0; i < daten.length; i++ ) {
		keys = zeilen[i].split(';');
		p = document.getElementById(keys[0]);

		if (keys.length > 1) {
			switch (keys[0]) {
				case "Stz2":
					setStatuszeile2(keys[1], 'white', 'black');
					break;
				case "Stz2S":
					setStatuszeile2(keys[1], 'yellow', 'green');
					break;
				case "Stz2F":
					setStatuszeile2(keys[1], 'yellow', 'red');
					break;
				case "time":
					rechnerzeit = keys[1];
					break;
				default:
					if (p !== null) {
						p.innerHTML = keys[1]; }
					break;
			}
		}
	}
}

